<?php

/*************************************************************
*  TorrentFlux PHP Torrent Manager - Windows Version
*  www.torrentflux.com
**************************************************************/
/*
    This file is part of TorrentFlux (Windows Version).

    TorrentFlux is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentFlux is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentFlux; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


include_once("config.php");
include_once("functions.php");

$messages = "";

// if we are to start a torrent then do so
if(isset($torrent))
{

	$alias = getAliasName($torrent);
	$owner = getOwner($torrent);
	// The following lines of code were suggested by Jody Steele jmlsteele@stfu.ca
	// This is to help manage user downloads by their user names
	//if the users path doesnt exist, create it
	if (!is_dir($cfg["path"] . "/" . $owner))
	{
		mkdir($cfg["path"] . "/" . $owner);
	}

	$execname = 'bt'.$alias.'.exe';

	// Change dir to binaries
	@chdir($cfg["btbindir"]);

	// Delete all the bt*.exe in the binary dir
	$temp = @exec('del bt*.exe');

	// Make an unique exe
	@copy($cfg["btphpbin"], $execname);

	// Change dir to downloadpath
	@chdir($cfg["path"]);

	// Start the download exe
	$winpath = str_replace('/','\\',$cfg["path"]);
	$command = 'cd '.$winpath.$owner.' & start '.$cfg["btbindir"].$execname." ".$cfg["torrent_dies_when_done"]." ".$cfg["torrent_file_path"].$alias.".stat ".$cfg['user']." --responsefile \"".$cfg["torrent_file_path"].$torrent."\" --display_interval 5 ".$cfg["cmd_options"];

	$result = Proc_Close (Proc_Open ($command, Array (), $foo));

	// start the alias file
	$output = "0.0\n0\n0\n0\n0\n0\n".getOwner($torrent);
	$fw	= fopen($cfg["torrent_file_path"].$alias.".stat","w");
	fwrite($fw, $output);
	fclose($fw);

	if($cfg["use_email"])
	{
		$msg  = "Torrent Started: ".$torrent."\n\n";
		$msg .= "message:  ".$result."\n\n";

		sendEmail("[TORRENT STARTED]", $msg);
	}

	AuditAction($cfg["constants"]["start_torrent"], $torrent);

	header("location: index.php");
}



// Do they want us to get a torrent via a URL?
if(isset($url_upload))
{
	$arURL = explode("/", $url_upload);
	$file_name = urldecode($arURL[count($arURL)-1]); // get the file name
	$file_name = str_replace(array("'",","), "", $file_name);
	$file_name = stripslashes($file_name);
	$ext_msg = "";

	if(strcmp(strtolower(substr($file_name, strlen($file_name)-8, 8)), ".torrent") == 0)
	{
		// Read the file
		$output = "";
		ini_set("allow_url_fopen", "1");
		ini_set("user_agent", "TorrentFlux ".$cfg["version"]);

		$url_upload = str_replace(" ", "%20", $url_upload);

		$fp = fopen($url_upload, "r");
		if ($fp !== NULL)
		{
			while (!feof($fp))
			{
				$output .= fread($fp, 8192);
			}

			fclose($fp);
		}


		// if the output had data then write it to a file
		if ((strlen($output) > 0) && (strpos($output, "<br />") === false))
		{
			if (is_file($cfg["torrent_file_path"].$file_name))
			{
				// Error
				$messages .= "<b>Error</b> with (<b>".$file_name."</b>), the file already exists on the server.<br><center><a href=\"".$_SERVER['PHP_SELF']."\">[Refresh]</a></center>";
				$ext_msg = "DUPLICATE :: ";
			}
			else
			{
				// open a file to write to
				$fw	= fopen($cfg["torrent_file_path"].$file_name,'w');
				fwrite($fw, $output);
				fclose($fw);
			}
		}
		else
		{
			$messages .= "<b>Error</b> Getting the File (<b>".$file_name."</b>), Could be a Dead URL.<br><center><a href=\"".$_SERVER['PHP_SELF']."\">[Refresh]</a></center>";
		}

		if($cfg["use_email"])
		{
			$msg  = "Torrent Uploaded via URL: ".$url_upload."\n\n";
			$msg .= "message:  ".$result."\n\n";

			sendEmail("[UPLOADED TORRENT]", $msg);
		}

	}
	else
	{
		// Error
		$messages .= "<b>Error</b> with (<b>".$file_name."</b>), make sure the file is a torrent.<br><center><a href=\"".$_SERVER['PHP_SELF']."\">[Refresh]</a></center>";
	}

	if ($messages == "")
	{
		AuditAction($cfg["constants"]["url_upload"], $file_name);
		header("location: index.php");
	}
	else
	{
		// there was an error
		AuditAction($cfg["constants"]["error"], $cfg["constants"]["url_upload"]." :: ".$ext_msg.$file_name);
	}
}

// Handle the file upload if there is one
if(!empty($HTTP_POST_FILES['upload_file']['name']))
{
	$file_name = stripslashes($HTTP_POST_FILES['upload_file']['name']);
	$file_name = str_replace(array("'",","), "", $file_name);
	$ext_msg = "";

    if($HTTP_POST_FILES['upload_file']['size'] <= $cfg["max_upload"] &&
       $HTTP_POST_FILES['upload_file']['size'] > $cfg["min_upload"])
    {
        if (ereg(getFileFilter($cfg["file_types_array"]), $file_name))
        {
            //FILE IS BEING UPLOADED
            if (is_file($cfg["torrent_file_path"].$file_name))
			{
				// Error
				$messages .= "<b>Error</b> with (<b>".$file_name."</b>), the file already exists on the server.<br><center><a href=\"".$_SERVER['PHP_SELF']."\">[Refresh]</a></center>";
				$ext_msg = "DUPLICATE :: ";
			}
			else
			{
				if(move_uploaded_file($HTTP_POST_FILES['upload_file']['tmp_name'], $cfg["torrent_file_path"].$file_name))
				{
					chmod($cfg["torrent_file_path"].$file_name, 0755);
					// send an email
					if($cfg["use_email"])
					{
						sendEmail("[UPLOAD]", "File Uploaded [".$file_name."]");
					}

					AuditAction($cfg["constants"]["file_upload"], $file_name);

					header("location: index.php");
				}
				else
				{
					$messages .= "<font color=\"#ff0000\" size=3>ERROR: File not uploaded, file could not be found or could not be moved:<br>".$cfg["torrent_file_path"] . $file_name."</font><br>";
				}
			}
        }
        else
        {
            $messages .= "<font color=\"#ff0000\" size=3>ERROR: The type of file you are uploading is not allowed.</font><br>";
        }
    }
    else
    {
        $messages .= "<font color=\"#ff0000\" size=3>ERROR: File not uploaded, check file size limit.</font><br>";
    }

	if($messages != "")
	{
		// there was an error
		AuditAction($cfg["constants"]["error"], $cfg["constants"]["file_upload"]." :: ".$ext_msg.$file_name);
	}
}  // End File Upload


// if a file was set to be deleted then delete it
if(isset($delfile))
{
	@unlink($cfg["torrent_file_path"].$delfile);
	@unlink($cfg["torrent_file_path"].$alias_file);
	if($cfg["use_email"])
	{
		sendEmail("[FILE DELETED]", "File DELETED: [".$delfile."]");
	}

	AuditAction($cfg["constants"]["delete_torrent"], $delfile);

	header("location: index.php");
}


// Did the user select the option to kill a running torrent?
if(isset($kill))
{
	// Yes, then do a shell exec for the KILL
	$kill = "bt".$kill.".exe";
	$result = shell_exec($cfg["btbindir"]."pskill ".$kill);
	sleep(2); // give it 2 seconds to close

	// Change dir to binaries
	@chdir($cfg["btbindir"]);

	// Delete all the bt*.exe in the binary dir
	$temp = @exec('del bt*.exe');

	$the_user = getOwner($kill_torrent);
	// read the alias file
	$arStatus = file($cfg["torrent_file_path"].$alias_file);
	$file_stat = $arStatus[0];
	if($file_stat < 100)
	{
		$file_stat = ($file_stat+100)*-1;
		// write over the status file so that we can display a new status
		$output = $file_stat."\n0\n0\n0\n".trim($arStatus[4])."\n".trim($arStatus[5])."\n".$the_user;
		if (sizeof($arStatus) > 7)
		{
			for ($inx = 7; $inx < sizeof($arStatus); $inx++)
			{
				if ($arStatus[$inx] != "")
				{
					$output .= "\n".$arStatus[$inx];
				}
			}
		}
		// open alias file to write to
		$fw	= fopen($cfg["torrent_file_path"].$alias_file,'w');
		fwrite($fw, $output);
		fclose($fw);
	}
	else
	{
		// write over the status file so that we can display a new status
		$output = "100\nDownload Succeeded!\n\n\n".trim($arStatus[4])."\n".trim($arStatus[5])."\n".$the_user;
		if (sizeof($arStatus) > 7)
		{
			for ($inx = 7; $inx < sizeof($arStatus); $inx++)
			{
				if ($arStatus[$inx] != "")
				{
					$output .= "\n".$arStatus[$inx];
				}
			}
		}
		// open alias file to write to
		$fw	= fopen($cfg["torrent_file_path"].$alias_file,'w');
		fwrite($fw, $output);
		fclose($fw);
	}


	if($cfg["use_email"])
	{
		$msg  = "Torrent KILL Requested: ".$kill."\n\n";
		$msg .= "message:  ".$result."\n\n";

		sendEmail("[KILL TORRENT]", $msg);
	}

	AuditAction($cfg["constants"]["kill_torrent"], $kill_torrent);

	header("location: index.php");
}

$drivespace = getDriveSpace($cfg["path"]);

?>


<html>
<HEAD>
    <TITLE><?PHP echo $cfg["pagetitle"] ?></TITLE>
    <LINK REL="StyleSheet" HREF="themes/<?PHP echo $cfg["theme"] ?>/style.css" TYPE="text/css">
    <META HTTP-EQUIV="Pragma" CONTENT="no-cache; charset=<?PHP echo _CHARSET ?>">
<?PHP
	if(!isset($refresh))
	{
		echo "<meta http-equiv=\"REFRESH\"content=\"".$cfg["page_refresh"].";URL=index.php\">";
	}

?>

<SCRIPT language="JavaScript">
function ShowDetails(name_file)
{
  window.open (name_file,'_blank','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=430,height=210')
}


function ConfirmDelete(file)
{
	return confirm("<?PHP echo _ABOUTTODELETE ?>: " + file)
}

</SCRIPT>

</HEAD>

<body topmargin="8" bgcolor="<?PHP echo $cfg["main_bgcolor"] ?>">

<div align="center">

<?PHP
if ($messages != "")
{
?>
<table border="1" cellpadding="10" bgcolor="#ff9b9b">
<tr>
	<td><div align="center"><?PHP echo $messages ?></div></td>
</tr>
</table><br><br>
<?PHP
}
?>


<table border="0" cellpadding="0" cellspacing="0" width="760">
<tr>
	<td>


<table border="1" bordercolor="<?PHP echo $cfg["table_border_dk"] ?>" cellpadding="4" cellspacing="0" width="100%">
<tr>
    <td colspan="2" background="themes/<?PHP echo $cfg["theme"] ?>/images/bar.gif">
	<?PHP DisplayTitleBar($cfg["pagetitle"]); ?>
    </td>
</tr>
<tr>
    <td bgcolor="<?PHP echo $cfg["table_header_bg"] ?>">
	<table width="100%" cellpadding="3" cellspacing="0" border="0">
	<tr>
		<form name="form_file" action="index.php" method="post" enctype="multipart/form-data">
		<td>
		<?PHP echo _SELECTFILE ?>:<br>
		<input type="File" name="upload_file" size="40">
		<input type="Submit" value="<?PHP echo _UPLOAD ?>">
		</td>
		</form>
	</tr>
	<tr>
		<form name="form_url" action="index.php" method="post">
		<td>
		<hr>
		<?PHP echo _URLFILE ?>:<br>
		<input type="text" name="url_upload" size="50">
		<input type="Submit" value="<?PHP echo _GETFILE ?>">
		</td>
		</form>
	</tr>
<?PHP
if ($cfg["enable_search"])
{
?>
	<tr>
		<form action="http://search.suprnova.org/search.php" method="get" name="searchForm" target="_blank">
		<td>
		<hr>
		<input name="data[sessionid]" value="<?PHP echo md5($_SERVER['REMOTE_ADDR']) ?>" type="hidden">
		<input name="data[action]" value="searchTorrent" type="hidden">
		<input name="data[searchType]" value="and" type="Hidden">
		<input name="data[searchDomain]" value="torrents" type="Hidden">
		<input name="data[type_id]" value="0" type="Hidden">
		<input name="data[category_id]" value="0" type="Hidden">
		<input name="data[orderby]" value="Date" type="Hidden">
		<input name="data[orderDir]" value="asc" type="Hidden">
		Suprnova Torrent <?PHP echo _SEARCH ?>:<br>
		<input name="data[searchTerm]" type="text" size="30">
		<input value="<?PHP echo _SEARCH ?>" accesskey="s" class="flat-button" type="Submit">
		</td>
		</form>
	</tr>
<?PHP
}
?>
	</table>


    </td>
	<td bgcolor="<?PHP echo $cfg["table_data_bg"] ?>" width="310" valign="top">
		<table width="100%" cellpadding="1" border="0">
		<tr>
		<td valign="top">
		<b><?PHP echo _TORRENTLINKS ?>:</b><br>
<?PHP
		$arLinks = GetLinks();
		foreach($arLinks as $link)
		{
			$arURL = parse_url($link);
			echo "<a href=\"".$link."\" target=\"_blank\"><img src=\"images/arrow.gif\" width=9 height=9 alt=\"".$link."\" border=0 align=\"baseline\">".$arURL['host']."</a><br>\n";
		}

		echo "</ul></td>";

		$arUsers = GetUsers();
		$arOnlineUsers = array();
		$arOfflineUsers = array();

		for($inx = 0; $inx < count($arUsers); $inx++)
		{
			if(IsOnline($arUsers[$inx]))
			{
				array_push($arOnlineUsers, $arUsers[$inx]);
			}
			else
			{
				array_push($arOfflineUsers, $arUsers[$inx]);
			}
		}

		echo "<td bgcolor=\"".$cfg["table_data_bg"]."\" valign=\"top\">";
		echo "<b>"._ONLINE.":</b><br>";

		for($inx = 0; $inx < count($arOnlineUsers); $inx++)
		{
			echo "<a href=\"message.php?to_user=".$arOnlineUsers[$inx]."\">";
			echo "<img src=\"images/user.gif\" width=17 height=14 alt=\"\" border=0 align=\"bottom\">". $arOnlineUsers[$inx];
			echo "</a><br>\n";
		}

		// Does the user want to see offline users?
		if ($cfg["hide_offline"] == false)
		{
			echo "<b>"._OFFLINE.":</b></br>";
			// Show offline users

			for($inx = 0; $inx < count($arOfflineUsers); $inx++)
			{
				echo "<a href=\"message.php?to_user=".$arOfflineUsers[$inx]."\">";
				echo "<img src=\"images/user_offline.gif\" width=17 height=14 alt=\"\" border=0 align=\"bottom\">".$arOfflineUsers[$inx];
				echo "</a><br>\n";
			}
		}

		echo "</td>";
?>
		</tr>
		</table>
	</td>
</tr>
<tr>
    <td bgcolor="<?PHP echo $cfg["table_header_bg"] ?>" colspan="2">

<?PHP
	displayDriveSpaceBar($drivespace);
?>

	</td>
</tr>
<tr>
    <td bgcolor="<?PHP echo $cfg["table_data_bg"] ?>" colspan="2">
	<div align="center">
    <font face="Arial" size="2">
	<a href="readrss.php">
	<img src="images/download_owner.gif" width="16" height="16" border="0" alt="RSS Torrents" align="absmiddle">RSS Torrents</a>
	 |
	<a href="drivespace.php">
	<img src="images/hdd.gif" width="16" height="16" border="0" alt="<?PHP echo $drivespace ?>% Used" align="absmiddle"><?PHP echo _DRIVESPACE ?></a>
	 |
	<a href="who.php">
	<img src="images/who.gif" width="16" height="16" alt="" border="0" align="absmiddle"><?PHP echo _SERVERSTATS ?></a>
	 |
	 <a href="dir.php">
	<img src="images/properties.png" width="18" height="13" alt="" border="0" align="absmiddle"><?PHP echo _DIRECTORYLIST ?></a>
	 |
	<a href="all_services.php">
	<img src="images/all.gif" width="16" height="16" alt="" border="0" align="absmiddle"><?PHP echo _ALL ?></a>
	</font>
	</div>
    </td>
</tr>
</table>

<?PHP
    getDirList($cfg["torrent_file_path"]);
?>
<tr><td bgcolor="<?PHP echo $cfg["table_header_bg"] ?>" colspan="5">
<font face="Arial" size="2">
<div align="center">

<?PHP
if(!isset($refresh))
{
	echo "<strong>*** "._PAGEWILLREFRESH." ".$cfg["page_refresh"]." "._SECONDS." ***</strong><br>
          <a href=\"".$_SERVER['PHP_SELF']."?refresh=off\">"._TURNOFFREFRESH."</a>";
}
else
{
	echo "<a href=\"".$_SERVER['PHP_SELF']."\">"._TURNONREFRESH."</a>";
}


if($drivespace >= 98)
{

	echo "\n\n<script  language=\"JavaScript\">\n alert(\""._WARNING.": ".$drivespace."% "._DRIVESPACEUSED."\")\n </script>";
}

// At this point Any User actions should have taken place
// Check to see if the user has a force_read message from an admin
if (IsForceReadMsg())
{
	// Yes, then warn them
?>
	<script  language="JavaScript">
	if (confirm("<?PHP echo _ADMINMESSAGE ?>"))
	{
		document.location = "readmsg.php";
	}
	</script>

<?PHP
}

?>

</div>
</font>
</td></tr>
</table>

<?PHP
	echo DisplayTorrentFluxLink();
?>

	</td>
</tr>
</table>


</body>
</html>